DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL w:dword
	LOCAL h:dword
	LOCAL row:dword
	LOCAL col:dword
	LOCAL buffer[4]:byte
	LOCAL buffer2[128]:byte
	
	push hWin
	pop hMain
	mov	eax,uMsg
	.if eax==WM_INITDIALOG
		mov staticBkgColor,00C8D0D4h

		invoke GetDlgItem,hWin,IDC_LSV1
		mov hListView,eax
		mov eax,wCell
		mov ecx,0fh
		inc ecx
		mul ecx
		add eax,7
		mov w,eax
		mov eax,hCell
		mov ecx,0fh
		inc ecx
		mul ecx
		add eax,6
		mov h,eax
		
		invoke SetWindowPos,hListView,0,30,30,w,h,SWP_NOZORDER
		invoke SetWindowLong,hListView,GWL_WNDPROC,addr LVWinProc
		mov OldLVWinProc,eax
		invoke CheckRadioButton,hWin,IDC_RBN1,IDC_RBN3,IDC_RBN1
		invoke SetUpStatusbar
		invoke SetUpListView
		invoke FillListView
		invoke SetFocus,hListView
		.if lParam!=-1 
			invoke CreateThread,NULL,NULL,offset ThreadProc,lParam,NORMAL_PRIORITY_CLASS,offset ThreadID
			invoke CloseHandle,eax
		.endif
	.elseif eax==WM_CLOSE
		invoke EndDialog,hWin,0
		
	.elseif uMsg == WM_COMMAND
		mov eax,wParam
		movzx edx,ax
		shr eax, 16
		.if edx==IDC_RBN1 && eax==BN_CLICKED
			invoke SendDlgItemMessage,hWin,IDC_BTN1,WM_SETTEXT,0,offset szInsertHex
		.elseif edx==IDC_RBN2 && eax==BN_CLICKED 
			invoke SendDlgItemMessage,hWin,IDC_BTN1,WM_SETTEXT,0,offset szInsertDec
		.elseif edx==IDC_RBN3 && eax==BN_CLICKED 
			invoke SendDlgItemMessage,hWin,IDC_BTN1,WM_SETTEXT,0,offset szInsertChar
		.elseif edx==IDC_BTN1 && eax==BN_CLICKED
			invoke GetValue,selectedCell.x,selectedCell.y
			push eax
			invoke IsDlgButtonChecked,hWin,IDC_RBN1 ;Hex
			.if eax==1
				pop eax
				.if (eax>=0Ah && eax<=0Fh) || (eax>=0A0h && eax<=0FFh)
					invoke wsprintf,addr buffer2,offset szFormatH,eax
				.else
					invoke wsprintf,addr buffer2,offset szFormatH2,eax
				.endif
				
			.else
				invoke IsDlgButtonChecked,hWin,IDC_RBN2 ;Dec
				.if eax==1
					pop eax
					invoke wsprintf,addr buffer2,offset szFormatD,eax
					
				.else ;Char
					pop eax ;to restor stack
					invoke getTextMatrix,selectedCell.x,selectedCell.y,addr buffer
					.if eax
						invoke wsprintf,addr buffer2,offset szFormatC,addr buffer
					.else
						mov byte ptr [buffer2],0
						invoke MessageBox,hWin,offset szNoCharater,offset szWarning,MB_OK or MB_ICONWARNING
					.endif
				.endif 
			.endif
			
			mov eax,lpHandles
			lea ecx,buffer2
			invoke SendMessage,[eax].ADDINHANDLES.hEdit,EM_REPLACESEL,TRUE,ecx
			invoke PostMessage,hWin,WM_COMMAND,IDABORT,NULL
			
		.endif
   .elseif uMsg == WM_NOTIFY
        mov edi,lParam
		assume edi:ptr NMHDR
		mov eax,[edi].hwndFrom
		.if eax==hListView
			.if [edi].code==NM_DBLCLK
				
				push [edi.NM_LISTVIEW].iItem
				pop row
				push [edi.NM_LISTVIEW].iSubItem
				pop col
				.if row!=-1
					invoke SelectionMark,row,col
				.endif
			.endif
		.endif
	.elseif eax==WM_CTLCOLORSTATIC
		invoke GetWindowLong,lParam,GWL_ID
		mov ecx,selectedCell.x
		add ecx,4000
		mov edx,selectedCell.y
		add edx,3000
		.if eax==ecx || eax==edx
			.if hBrush
				invoke DeleteObject,hBrush
			.endif
			invoke SetBkMode,wParam,TRANSPARENT
			invoke CreateSolidBrush,staticBkgColor
			mov hBrush,eax
			ret
		.elseif eax==IDC_STC3
			.if hBrush
				invoke DeleteObject,hBrush
			.endif
			invoke SetBkMode,wParam,TRANSPARENT
			invoke CreateSolidBrush,00A2FFFFh
			mov hBrush,eax
			ret
		.endif
		mov eax,FALSE
		ret
	.else
		mov eax,FALSE
		ret
	.endif
	mov eax,TRUE
	ret

DlgProc endp

DrawRect proc penStyle:dword,color:dword,row:dword,col:dword
	LOCAL hDC:dword
	LOCAL hPen:dword
	LOCAL pt:POINT
	
	invoke CreatePen,penStyle,2,color
	mov hPen,eax
	invoke GetDC,hListView
	mov hDC,eax
	invoke SelectObject,hDC,hPen
	
	mov eax,wCell
	mov ecx,col
	mul ecx
	inc eax
	mov pt.x,eax
	mov dword ptr[pointArray + 16],eax
	mov dword ptr[pointArray + 24],eax
	
	mov eax,hCell
	mov ecx,row
	mul ecx
	inc eax
	mov pt.y,eax
	mov dword ptr[pointArray + 4],eax
	mov dword ptr[pointArray + 28],eax
	invoke MoveToEx,hDC,pt.x,pt.y,NULL
	
	mov eax,pt.x
	add eax,wCell
	sub eax,2
	mov dword ptr[pointArray],eax
	mov dword ptr[pointArray + 8],eax
	
	mov eax,pt.y
	add eax,hCell
	sub eax,2
	mov dword ptr[pointArray + 12],eax
	mov dword ptr[pointArray + 20],eax
	
	invoke PolylineTo,hDC,offset pointArray,4
	invoke DeleteObject,hPen
					
	ret
DrawRect endp

SelectionMark proc row:dword,col:dword
	LOCAL buffer[4]:byte
	LOCAL buffer2[128]:byte
	
	invoke RedrawWindow,hListView,NULL,NULL,RDW_ERASE or RDW_INVALIDATE or RDW_UPDATENOW	
	invoke GetDlgItem,hMain,IDC_BTN1
	invoke EnableWindow,eax,TRUE
	invoke lstrcpy,addr buffer2,offset szChar
	invoke getTextMatrix,row,col,addr buffer
	.if eax
		invoke lstrcat,addr buffer2,addr buffer
	.endif
	invoke SendMessage,hStatus,SB_SETTEXT,2,addr buffer2
	
	invoke GetValue,row,col
	push eax
	invoke wsprintf,addr buffer2,offset szFormatHex,eax
	invoke SendMessage,hStatus,SB_SETTEXT,0,addr buffer2
	
	pop eax
	invoke wsprintf,addr buffer2,offset szFormatDec,eax
	invoke SendMessage,hStatus,SB_SETTEXT,1,addr buffer2
			
	invoke GetValue,row,col
	.if eax==0 
		mov eax,256
	.endif
	lea ecx,buffer2
	invoke LoadString,hInstance,eax,ecx,sizeof buffer2
	invoke SendMessage,hStatus,SB_SETTEXT,3,addr buffer2

	;Rows
	mov staticBkgColor,00C8D0D4h
	mov eax,selectedCell.x
	add eax,4000
	invoke GetDlgItem,hMain,eax
	invoke InvalidateRect,eax,NULL,TRUE
	;Columns
	mov staticBkgColor,00C8D0D4h
	mov eax,selectedCell.y
	add eax,3000
	invoke GetDlgItem,hMain,eax
	invoke InvalidateRect,eax,NULL,TRUE
	invoke UpdateWindow,hMain
	
	mov eax,col
	mov selectedCell.y,eax
	mov eax,row
	mov selectedCell.x,eax
	;Rows
	mov staticBkgColor,0000FFFFh
	mov eax,row
	add eax,4000
	invoke GetDlgItem,hMain,eax
	invoke InvalidateRect,eax,NULL,TRUE
	invoke GetDlgItem,hMain,IDC_BTN1
	invoke SetFocus,eax
	;Columns
	mov staticBkgColor,0000FFFFh
	mov eax,col
	add eax,3000
	invoke GetDlgItem,hMain,eax
	invoke InvalidateRect,eax,NULL,TRUE
	
	invoke DrawRect,PS_SOLID,000000FFh,row,col
	ret

SelectionMark endp

ThreadProc PROC Param:DWORD
	LOCAL row:dword
	LOCAL col:dword
	
	invoke Sleep,100
	mov eax,Param
	.if eax<0Fh
		mov row,0
		mov col,eax
	.else
		push eax
		shr eax,4
		mov row,eax
		pop eax
		and eax,0fh
		mov col,eax
	.endif
	invoke SelectionMark,row,col

    ret
    
ThreadProc ENDP
